(game-module "old-empire"
  (blurb "This is an emulation of `Old Empire', a distant ancestor of Xconq.")
)

(unit-type army (char "A") (image-name "soldiers"))
(unit-type fighter (char "F") (image-name "jets"))
(unit-type destroyer (char "D") (image-name "dd"))
(unit-type submarine (char "S") (image-name "sub"))
(unit-type troop-transport (char "T") (image-name "ap"))
(unit-type cruiser (char "R") (image-name "cruiser"))
(unit-type carrier (char "C") (image-name "cv"))
(unit-type battleship (char "B") (image-name "bb"))
(unit-type city (char "@") (image-name "city20"))

; avgas is used only to constrain fighter range.

(material-type avgas)

(terrain-type sea (color "sky blue") (char "."))
(terrain-type land (color "green") (char "+"))

(define A army)
(define F fighter)
(define D destroyer)
(define S submarine)
(define T troop-transport)
(define R cruiser)
(define C carrier)
(define B battleship)
(define @ city)

(define ship (D S T R C B))

;land default-terrain  ; for compatibility with other maps

(add t* alt-percentile-min (0 70))
(add t* alt-percentile-max (70 100))
(add t* wet-percentile-min 0)
(add t* wet-percentile-max 100)

(add city start-with 1)

(table independent-density
  (city land 100))

;true @ named

(table favored-terrain
  (city (sea land) (0 100)))

;true @ already-seen
;
;2 A @ capacity          ; must have capacity for units being built
;100 F @ capacity        ; essentially infinite?
;100 ship @ capacity
;6 A T capacity
;8 F C capacity

(add (A F) acp-per-turn (1 4))
(add ship acp-per-turn 2)
(add @ acp-per-turn 1)

(add (A F) speed (1 4))
(add ship speed 2)

(table mp-to-enter-terrain
  (army sea 10)
  (ship land 10)
  )

;4 u* F enter-time

(table acp-to-create
  (@ u* 1)
  (@ @ 0)
  )

;[ 5 10 20 30 25 50 60 75 0 ] u* @ make
;true @ maker               ; very important!
;20 u* startup              ; why does original empire doc list out the numbers?
;1 ship @ repair
;

(add u* hp-max (1 1 3 3 2 8 8 12 1))

;[ 0 0 2 2 1 4 4  6 0 ] u* crippled

(table hit-chance
  (u* u* 50)
  (u* @ 0)
  (@ u* 0)
  )

(table damage
  (u* u* 1)
  (S ship 3)  ; subs hit only ships harder
  )

;50 @ A capture          ; note that armies capture cities without hitting them
;1 @ A guard             ; use up the capturing army
;
;"shoots down" F destroy-message
;"sinks" ship destroy-message
;
;;; Model limited fighter range.  Carriers and cities should have essentially
;;; infinite fuel supply.
;
;20 avgas F storage
; 1 avgas F to-move
; 4 avgas F consume
;5000 avgas [ C @ ] storage
;5000 avgas @ produce
;100 land @ productivity
;100 sea C productivity
;
;"runs out of fuel and crashes" F starve-message
;
;1 @ territory           ; need this so machine player goes after right stuff
;
;true @ neutral

(game-module (notes
  "Of course, this will not be exactly like empire - for one thing, xconq maps"
  "are in hexes and not in squares!  However, we can reproduce the details"
  "of the playing pieces fairly well."
  ""
  "The chief defects are that combat is always mutual, rather than"
  "one-side-at-a-time hits, and that cities must have capacity for armies."
  "In the latter case, this period fixes an annoying defect of the original"
  "empire game!  Also, some of the messages are a little weird."
  ""
  "There is also an imbalance in that ships defeating armies don't run"
  "aground, so they are more useful than in the original."
))
