/* Copyright (c) 1992  Stanley T. Shebs. */
/* This program may be used, copied, modified, and redistributed freely */
/* for noncommercial purposes, so long as this notice remains intact. */

/* Definitions for the historical record. */

typedef enum {

#undef  DEF_HEVT
#define DEF_HEVT(CODE, name, datadescs) CODE,

#include "history.def"

    NUMHEVTTYPES
} HistEventType;

typedef struct a_hevt_defn {
    char *name;
    char *datadescs;
} HevtDefn;

/* Reasons for gains and losses of units. */

typedef enum a_reason {
    FIRSTUNIT =   0,
    PRODUCED =    1,
    CAPTURE =     2,
    DUMMYREAS =   3,
    COMBAT =      4,
    PRISONER =    5,
    GARRISON =    6,
    DISASTER =    7,
    STARVATION =  8,
    DISBAND =     9,
    LEFTMAP =    10,
    SURRENDER =  11,
    VICTOR =     12,
    ENDOFWORLD = 13,
    NUMREASONS = 14
} Reason;

#define REASONNAMES \
  { "Ini", "Pro", "Cap", "   ", \
    "Cbt", "Pri", "Gar", "Acc", "Sup", "Dis", "Lft", "Sur", "Win", "End" }

typedef struct a_histevent {
    HistEventType type;
    int subtype;
    int summary;
    int startdate;
    int startseq;
    int enddate;
    int endseq;
    /* need something to describe who knows about the event? */
#if (MAXSIDES < 32)
    long observers;
#else
    long observers[MAXSIDES];
#endif
    struct a_histevent *next;
    struct a_histevent *prev;
    /* what are the possible data formats? */
    char *data;
} HistEvent;

extern HevtDefn hevtdefns[];

extern HistEvent *history;

HistEvent *create_historical_event();
HistEvent *record_event();

/* Accessors (usable for both getting and setting) to the statistics
   arrays of a side. */

#define side_balance(s,u,r) ((s)->balance[NUMREASONS*(u) + (r)])

#define side_atkstats(s,u1,u2) ((s)->atkstats[numutypes*(u1) + (u2)])

#define side_hitstats(s,u1,u2) ((s)->hitstats[numutypes*(u1) + (u2)])

